osg::Box Class Reference

`#include <Shape>`

Inheritance diagram for osg::Box:

## Public Member Functions

| Box ()
| Box (const Vec3 &center, float width)
| Box (const Vec3 &center, float lengthX, float lengthY, float lengthZ)
| Box (const Box &box, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Shape (osg, Box)
bool | valid () const
void | set (const Vec3 &center, const Vec3 &halfLengths)
void | setCenter (const Vec3 &center)
const Vec3 & | getCenter () const
void | setHalfLengths (const Vec3 &halfLengths)
const Vec3 & | getHalfLengths () const
void | setRotation (const Quat &quat)
const Quat & | getRotation () const
Matrix | computeRotationMatrix () const
bool | zeroRotation () const
Public Member Functions inherited from osg::Shape
| Shape ()
| Shape (const Shape &sa, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual void | accept (ShapeVisitor &)=0
virtual void | accept (ConstShapeVisitor &) const =0
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Box ()
Protected Member Functions inherited from osg::Shape
virtual | ~Shape ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

Vec3 | _center
Vec3 | _halfLengths
Quat | _rotation
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Constructor & Destructor Documentation

## Box() [1/4]

osg::Box::Box | ( |  | ) |

inline

References _center, and _halfLengths.

Referenced by Box(), and META_Shape().

## Box() [2/4]

osg::Box::Box | ( | const Vec3 & | center,
|  | float | width )

inline

References _center, and _halfLengths.

## Box() [3/4]

osg::Box::Box | ( | const Vec3 & | center,
|  | float | lengthX,
|  | float | lengthY,
|  | float | lengthZ )

inline

References _center, and _halfLengths.

## Box() [4/4]

osg::Box::Box | ( | const Box & | box,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

inline

References _center, _halfLengths, _rotation, Box(), osg::CopyOp::SHALLOW_COPY, and osg::Shape::Shape().

## ~Box()

virtual osg::Box::~Box | ( |  | ) |

protected virtual

## Member Function Documentation

## computeRotationMatrix()

Matrix osg::Box::computeRotationMatrix | ( |  | ) | const

inline

References _rotation.

## getCenter()

const Vec3 & osg::Box::getCenter | ( |  | ) | const

inline

References _center.

## getHalfLengths()

const Vec3 & osg::Box::getHalfLengths | ( |  | ) | const

inline

References _halfLengths.

## getRotation()

const Quat & osg::Box::getRotation | ( |  | ) | const

inline

References _rotation.

## META_Shape()

osg::Box::META_Shape | ( | osg | ,
|  | Box | )

References Box().

## set()

void osg::Box::set | ( | const Vec3 & | center,
|  | const Vec3 & | halfLengths )

inline

References _center, and _halfLengths.

## setCenter()

void osg::Box::setCenter | ( | const Vec3 & | center | ) |

inline

References _center.

## setHalfLengths()

void osg::Box::setHalfLengths | ( | const Vec3 & | halfLengths | ) |

inline

References _halfLengths.

## setRotation()

void osg::Box::setRotation | ( | const Quat & | quat | ) |

inline

References _rotation.

## valid()

bool osg::Box::valid | ( |  | ) | const

inline

References _halfLengths.

## zeroRotation()

bool osg::Box::zeroRotation | ( |  | ) | const

inline

References _rotation.

## Member Data Documentation

## _center

Vec3 osg::Box::_center

protected

Referenced by Box(), Box(), Box(), Box(), getCenter(), set(), and setCenter().

## _halfLengths

Vec3 osg::Box::_halfLengths

protected

Referenced by Box(), Box(), Box(), Box(), getHalfLengths(), set(), setHalfLengths(), and valid().

## _rotation

Quat osg::Box::_rotation

protected

Referenced by Box(), computeRotationMatrix(), getRotation(), setRotation(), and zeroRotation().

The documentation for this class was generated from the following file:

- Shape